
set echo on
set serveroutput on

col object_instance format a40
col o format a40
col treated_subtype format a40
col record_type format a18
col subtype_record format a40
col another_subtype_record format a40
set num 9
col st_attr2 format a9
col st_attr3 format a9
col type_id format a7


CREATE TYPE supertype_ntt AS
   TABLE OF supertype_ot;
/

CREATE FUNCTION f RETURN supertype_ntt PIPELINED AS
BEGIN
   PIPE ROW (subtype_ot(1, SYSDATE, 'A'));
   PIPE ROW (another_subtype_ot(1,2,3,4));
   PIPE ROW (subtype_ot(2, SYSDATE, 'B'));
   PIPE ROW (another_subtype_ot(2,3,4,5));
   PIPE ROW (subtype_ot(3, SYSDATE, 'C'));
   RETURN;
END f;
/

SELECT t.*
FROM   TABLE(f) t;

SELECT VALUE(t) AS object_instance
FROM   TABLE(f) t;

CREATE VIEW v
AS
   SELECT VALUE(t) AS o
   FROM   TABLE(f) t;

SELECT *
FROM   v
WHERE  o IS OF TYPE (subtype_ot);

SELECT *
FROM   v
WHERE  o IS OF (ONLY another_subtype_ot);

SELECT *
FROM   v
WHERE  o IS OF (ONLY supertype_ot);

SELECT SYS_TYPEID(o) AS type_id
,      o             AS object_instance
FROM   v;

SELECT TREAT(o AS subtype_ot) AS treated_subtype
FROM   v
WHERE  o IS OF (ONLY subtype_ot);

SELECT TREAT(o AS subtype_ot).attr1 AS attr1
,      TREAT(o AS subtype_ot).attr2 AS attr2
,      TREAT(o AS subtype_ot).attr3 AS attr3
FROM   v
WHERE  o IS OF TYPE (subtype_ot);

SELECT CASE
          WHEN o IS OF TYPE (subtype_ot)
          THEN 'SUBTYPE_OT'
          ELSE 'ANOTHER_SUBTYPE_OT'
       END                            AS record_type
,      TREAT(o AS subtype_ot)         AS subtype_record
,      TREAT(o AS another_subtype_ot) AS another_subtype_record
FROM   v;

SELECT ilv.record_type                  AS record_type
,      ilv.subtype_record.attr1         AS st_attr1
,      ilv.subtype_record.attr2         AS st_attr2
,      ilv.subtype_record.attr3         AS st_attr3
,      ilv.another_subtype_record.attr1 AS ast_attr1
,      ilv.another_subtype_record.attr2 AS ast_attr2
,      ilv.another_subtype_record.attr3 AS ast_attr3
,      ilv.another_subtype_record.attr4 AS ast_attr4
FROM  (
       SELECT CASE
                 WHEN o IS OF TYPE (subtype_ot)
                 THEN 'SUBTYPE'
                 ELSE 'ANOTHER SUBTYPE'
              END                            AS record_type
       ,      TREAT(o AS subtype_ot)         AS subtype_record
       ,      TREAT(o AS another_subtype_ot) AS another_subtype_record
       FROM   v
      ) ilv;




